function PerformSegmentation(className)
working_add=['working/',className];
output_dir=['output/',className];
imageFolder=['positiveImage/',className]; % folder of training images  
html_dir=['document/',className];
    
GlobalParameters;
ParameterCodeImage;
close all;

SUM1MAX1;
storeExponentialModelName = ['storedExponentialModel' num2str(1)];   
load(storeExponentialModelName);
storedlambda = single(storedlambda);
storedExpectation = single(storedExpectation);
storedLogZ = single(storedLogZ);

Correlation = CorrFilter(allFilter, epsilon);  % correlation between filters 
for j = 1:numel(Correlation)
    Correlation{j} = single(Correlation{j});
end
for j = 1:numel(allSymbol)
    allSymbol{j} = single(allSymbol{j});
end



%% begin clustering with window scanning in E step

% initialize: generate random SUM2 maps and thus random cluster members
mixing = zeros(numCluster,1); % number of examples in each cluster
aveLogL = zeros(numCluster,1); % average log likelihood in each cluster
bestOverallScore = -inf;
buf_length = 0;
for iRS = 1:numRandomStart
    
    %% initial step
    InitialActivations;
    numElementAll = zeros(1, numCluster); 
  
    for iter = 1:numIter
        %% EM step
        learnSketch;
        learnColorModelAndSegment;
        estimateLocation;
    end

    save([working_add,'\activations.mat'], 'activations' );
    %fprintf(1,'\n');

    % compute overall Score
	scores = activations(6,:);
    scores = max(scores,0);
	overallScore = sum(scores); % use mean or sum ?
	
	if overallScore > bestOverallScore
		bestOverallScore = overallScore;
		bestS2Templates = S2Templates;
		bestInitialClusters = initialClusters;
		bestActivations = activations;
        bestMixing = mixing;
        bestAveLogL = aveLogL;
	end

end
fprintf(1,'\n');

% -- now we have selected the best random starting point --
%% display the templates and cluster members for the best random starting point
storeBestResult;
learnColorModelAndSegment;
save([working_add,'/segmentation_result.mat'],'LSet', 'mSLset', 'shapeSegModels');

% show html file
GenerateHtml;
