function r = computeLabelSUM2(labelMap,TransformedShapeSegModels,templateSize)
spady = double(floor(templateSize(1)/4));
spadx = double(floor(templateSize(2)/4));
temp(:,:,1) = padarray(double(labelMap==1),[spady spadx],0);
temp(:,:,2) = padarray(double(labelMap==-1),[spady spadx],1);

% temp(:,:,1) = double(labelMap==1);
% temp(:,:,2) = double(labelMap==-1);

r = fconvfft(temp,TransformedShapeSegModels);
for i = 1:length(r)
    % normalize response array size so all responses at this 
    % level have the same dimension
    spady = floor((size(labelMap,1) - size(r{i},1))/2);
    spadx = floor((size(labelMap,2) - size(r{i},2))/2);
    mr = mean(r{i}(:));
    r{i} = padarray(r{i}, [spady spadx], mr);
    spady = size(labelMap,1) - size(r{i},1);
    spadx = size(labelMap,2) - size(r{i},2);
    r{i} = padarray(r{i}, [spady spadx], mr,'post');
end