function r = fconvfft(image,templates)
r = {};
depth = size(image,3);
for i=1:numel(templates)
    r{i} = conv2fft(image(:,:,1),templates{i}(:,:,1),'valid');
    for d=2:depth
        r{i} = r{i} + conv2fft(image(:,:,d),templates{i}(:,:,d),'valid');
    end
    r{i} = r{i}/numel(templates{i}(:,:,1));
end