partSizeX = templateSize(1);
partSizeY = templateSize(2);

% read the training examples
Iname = dir([imageFolder,'/*.bmp']);
Iname = [Iname; dir([imageFolder '/*.jpg'])];
Iname = [Iname; dir([imageFolder '/*.png'])];
n = length(Iname);
selected_img = 1:n;

mScaleImSet = cell(n,1);
initMapSet = cell(n,1);
for img = selected_img

	% load SUM1/MAX1 map
	multipleResolutionImageName = [working_add '/multipleResolutionImage' num2str(img)];
	load(multipleResolutionImageName, 'Jc');
	% find activations
	ind = find( activations(1,:) == img );
	
	maskMap = genInitSegMap(Jc, activations(:,ind), nTransform, numOrient, templateTransform, partSizeX, partSizeY, border);
    
    for s = 1:numel(Jc)
        mScaleImSet{img}{s} = double(Jc{s});
    end
    initMapSet{img} = maskMap;
    
%     [L, dc , sc, vC, hC] = GrabCut(double(Jc{end}), maskMap);
%        
%     L3 = repmat(L,[1,1,3]);
%     resIm = Jc{end};
%     resIm(L3==-1) = 255;
%     figure;imshow(resIm);
end

[LSet, mSLset, shapeSegModels] = CoGrabCut2(mScaleImSet, initMapSet, working_add, saturation, activations, numCluster, nTransform, numOrient, templateTransform, outRow, outCol, partSizeX, partSizeY, border, bUseUncoveredPrior);


