clear
close all


%% mex-C compilation
cd('./GCmex2.0');
compile_gc;
cd('..');

mex mexc_ComputeMAX1.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_Histogram.cpp	% pool histogram from negative images
mex mexc_LocalNormalize.cpp	% local normalization of type single (float)
mex mexc_SharedSketch.cpp	% learning by shared sketch algorithm (with data weights)
mex mexc_ComputeMAX2.cpp
mex mexc_ComputeMAX2MP.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp

%% preparation
addpath('./GCmex2.0');
GlobalParameters;
ExponentialModel;
clear;
close all;

classes = {'bike','cow','chair','face','flower','house','sheep','sign','tree'};

parfor classInd = 1:numel(classes)
    PerformCosegmentation(classes{classInd});
end