function TransformedFlatTemplates = genTransformedFlatTemplates(FlatTemplates, templateTransform, numOrient)
numCluster = numel(FlatTemplates);
nTransform = numel(templateTransform);

TransformedFlatTemplates = cell(nTransform,numCluster);
% CHANGE XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
for cc = 1:numCluster
    for iT = 1:nTransform
        templateScaleInd = templateTransform{iT}(1);
        rowScale = templateTransform{iT}(2);
        colScale = templateTransform{iT}(3);
        rotation = templateTransform{iT}(4);
        reflection = templateTransform{iT}(5);

        curSelectedRow = FlatTemplates{cc}.Mx;
        curSelectedCol = FlatTemplates{cc}.My;
        curSelectedOri = zeros(length(curSelectedRow),1,'single');
        curSelectedScale = zeros(length(curSelectedRow),1,'single');
        if reflection < 0
            curSelectedCol = -curSelectedCol+1;
        end
        [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
            mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
            colScale, rotation, curSelectedRow, curSelectedCol,...
            curSelectedOri, curSelectedScale, numOrient);
        TransformedFlatTemplates{iT,cc}.selectedRow = tmpSelectedRow;
        TransformedFlatTemplates{iT,cc}.selectedCol = tmpSelectedCol;
        TransformedFlatTemplates{iT,cc}.selectedOri = zeros(size(tmpSelectedOri));
        TransformedFlatTemplates{iT,cc}.selectedScale = tmpSelectedScale;
        TransformedFlatTemplates{iT,cc}.selectedLambda = FlatTemplates{cc}.lambda;
        TransformedFlatTemplates{iT,cc}.selectedLogZ = FlatTemplates{cc}.logZ;
    end
end
